diff --git a/game/core/src/main/java/net/minecraft/core/world/noise/WorleyNoise.java b/game/core/src/main/java/net/minecraft/core/world/noise/WorleyNoise.java
new file mode 100644
index 000000000..073ab4987
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/world/noise/WorleyNoise.java
@@ -0,0 +1,173 @@
+package net.minecraft.core.world.noise;
+
+import net.minecraft.core.util.helper.MathHelper;
+import org.jetbrains.annotations.NotNull;
+import org.joml.Vector2f;
+import org.joml.Vector2fc;
+import org.joml.Vector3f;
+import org.joml.Vector3fc;
+
+// NOTE: code shamelessly stolen from https://www.shadertoy.com/view/MslGD8,
+// https://www.reddit.com/r/proceduralgeneration/comments/4u0s1i/infinite_worleycellularvoroni_noise/,
+// and https://www.shadertoy.com/view/ldl3W8
+public final class WorleyNoise {
+    public static class Result {
+        public float distance;
+        public int index;
+    }
+    private WorleyNoise() { }
+
+    private static final @NotNull Vector2fc HASH_CONST_2D_A = new Vector2f(127.1f, 311.7f);
+    private static final @NotNull Vector2fc HASH_CONST_2D_B = new Vector2f(269.5f, 183.3f);
+    private static final @NotNull Vector3fc HASH_CONST_3D_A = new Vector3f(127.1f, 311.7f, 74.7f);
+    private static final @NotNull Vector3fc HASH_CONST_3D_B = new Vector3f(269.5f ,183.3f ,246.1f);
+    private static final @NotNull Vector3fc HASH_CONST_3D_C = new Vector3f(113.5f, 271.9f, 124.6f);
+    private static final float HASH_CONST_MULT = 18.5453f;
+
+    public static void getWorleyDistance2d(final @NotNull Vector2fc xy, final @NotNull Result result) {
+        final @NotNull Vector2fc ip = xy.floor(new Vector2f()); // nearest gridpoint
+        final @NotNull Vector2fc fp = xy.sub(ip, new Vector2f()); // fractional distance from gridpoint
+
+        final @NotNull Vector2f mg = new Vector2f();
+        final @NotNull Vector2f mr = new Vector2f();
+        float md = 8.0f;
+        int index = 0;
+
+        final @NotNull Vector2f g = new Vector2f();
+        final @NotNull Vector2f o = new Vector2f();
+        final @NotNull Vector2f r = new Vector2f();
+        final @NotNull Vector2f pos = new Vector2f();
+
+        // First pass - regular voronoi
+        for (int i = -1; i <= 1; i++) {
+            for (int j = -1; j <= 1; j++) {
+                g.set(i, j);
+                hash(ip.add(g, pos), o); // o gives the offset of the gridpoint to use for lookup
+                g.add(o, r).sub(fp); // r gives distance to the point of interest in either direction
+                final float d = r.dot(r); // distance to gridpoint
+                if (d < md) { // check if this is the closest point
+                    md = d; // if it is, save the distance
+                    mr.set(r);
+                    mg.set(g);
+                    index = (int) (o.x * 10.0f) + (int) (o.y * 10.0f);
+                }
+            }
+        }
+
+        // Second pass - distance to borders
+        md = 8.0f;
+        for (int i = -2; i <= 2; i++) {
+            for (int j = -2; j <= 2; j++) {
+                g.set(mg).add(i, j);
+                ip.add(g, pos);
+                hash(ip.add(g, pos), o);
+                g.add(o, r).sub(fp); // r gives distance to the point of interest in either direction
+                pos.set(mr).sub(r);
+                if (pos.dot(pos) > 0.00001f) {
+                    g.set(mr).add(r).mul(0.5f);
+                    o.set(r).sub(mr).normalize();
+                    md = Math.min(md, g.dot(o));
+                }
+            }
+        }
+
+        result.distance = 1.0f - md;
+        result.index = index;
+    }
+
+    public static void getWorleyDistance3d(final @NotNull Vector3fc xyz, final @NotNull Result result) {
+        final @NotNull Vector3fc ip = xyz.floor(new Vector3f());
+        final @NotNull Vector3fc fp = xyz.sub(ip, new Vector3f());
+
+        final @NotNull Vector3f mg = new Vector3f();
+        final @NotNull Vector3f mr = new Vector3f();
+        float md = 8.0f;
+        int index = 0;
+
+        final @NotNull Vector3f g = new Vector3f();
+        final @NotNull Vector3f o = new Vector3f();
+        final @NotNull Vector3f r = new Vector3f();
+        final @NotNull Vector3f pos = new Vector3f();
+
+        // First pass - regular voronoi
+        for (int i = -1; i <= 1; i++) {
+            for (int j = -1; j <= 1; j++) {
+                for (int k = -1; k <= 1; k++) {
+                    g.set(i, j, k);
+                    hash(ip.add(g, pos), o); // o gives the offset of the gridpoint to use for lookup
+                    g.add(o, r).sub(fp); // r gives distance to the point of interest in either direction
+                    final float d = r.dot(r); // distance to gridpoint
+                    if (d < md) { // check if this is the closest point
+                        md = d; // if it is, save the distance
+                        mr.set(r);
+                        mg.set(g);
+                        index = (int) (o.x * 10.0f) + (int) (o.y * 10.0f) + (int) (o.z * 10.0f);
+                    }
+                }
+            }
+        }
+
+        // Second pass - distance to borders
+        md = 8.0f;
+        for (int i = -2; i <= 2; i++) {
+            for (int j = -2; j <= 2; j++) {
+                for (int k = -2; k <= 2; k++) {
+                    g.set(mg).add(i, j, k);
+                    ip.add(g, pos);
+                    hash(ip.add(g, pos), o);
+                    g.add(o, r).sub(fp); // r gives distance to the point of interest in either direction
+                    pos.set(mr).sub(r);
+                    if (pos.dot(pos) > 0.00001f) {
+                        g.set(mr).add(r).mul(0.5f);
+                        o.set(r).sub(mr).normalize();
+                        md = Math.min(md, g.dot(o));
+                    }
+                }
+            }
+        }
+
+        result.distance = 1.0f - md;
+        result.index = index;
+    }
+
+    private static void hash(final @NotNull Vector2fc p, final @NotNull Vector2f out) {
+        out.x = p.dot(HASH_CONST_2D_A);
+        out.y = p.dot(HASH_CONST_2D_B);
+
+        sin(out, out);
+        out.mul(HASH_CONST_MULT, out);
+        fract(out, out);
+    }
+
+    private static void hash(final @NotNull Vector3fc p, final @NotNull Vector3f out) {
+        out.x = p.dot(HASH_CONST_3D_A);
+        out.y = p.dot(HASH_CONST_3D_B);
+        out.z = p.dot(HASH_CONST_3D_C);
+
+        sin(out, out);
+        out.mul(HASH_CONST_MULT, out);
+        fract(out, out);
+    }
+
+    private static void sin(final @NotNull Vector2fc p, final @NotNull Vector2f out) {
+        out.x = (float) Math.sin(p.x());
+        out.y = (float) Math.sin(p.y());
+    }
+
+    private static void sin(final @NotNull Vector3fc p, final @NotNull Vector3f out) {
+        out.x = (float) Math.sin(p.x());
+        out.y = (float) Math.sin(p.y());
+        out.z = (float) Math.sin(p.z());
+    }
+
+    private static void fract(final @NotNull Vector2fc p, final @NotNull Vector2f out) {
+        out.x = p.x() - MathHelper.floor_float(p.x());
+        out.y = p.y() - MathHelper.floor_float(p.y());
+    }
+
+    private static void fract(final @NotNull Vector3fc p, final @NotNull Vector3f out) {
+        out.x = p.x() - MathHelper.floor_float(p.x());
+        out.y = p.y() - MathHelper.floor_float(p.y());
+        out.z = p.z() - MathHelper.floor_float(p.z());
+    }
+}
diff --git a/game/core/src/main/java/net/minecraft/core/world/pos/TilePos.java b/game/core/src/main/java/net/minecraft/core/world/pos/TilePos.java
index b6b2f5a2e..9822b05e3 100644
--- a/game/core/src/main/java/net/minecraft/core/world/pos/TilePos.java
+++ b/game/core/src/main/java/net/minecraft/core/world/pos/TilePos.java
@@ -249,7 +249,7 @@ public final class TilePos implements Externalizable, Cloneable, TilePosc {
                 this.y >= 0 &&
                 this.z >= World.MIN_BLOCK_Z &&
                 this.x <= World.MAX_BLOCK_X &&
-                this.y < source.getHeightBlocks() &&
+                this.y <= source.getHeightBlocks() &&
                 this.z <= World.MAX_BLOCK_Z;
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworld.java b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworld.java
index 04e0c4070..f203f4580 100644
--- a/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworld.java
+++ b/game/core/src/main/java/net/minecraft/core/world/type/overworld/WorldTypeOverworld.java
@@ -3,8 +3,10 @@ package net.minecraft.core.world.type.overworld;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.util.helper.MathHelper;
 import net.minecraft.core.world.World;
+import net.minecraft.core.world.biome.Biomes;
 import net.minecraft.core.world.biome.provider.BiomeProvider;
 import net.minecraft.core.world.biome.provider.BiomeProviderOverworld;
+import net.minecraft.core.world.biome.provider.BiomeProviderSingleBiome;
 import net.minecraft.core.world.config.season.SeasonConfig;
 import net.minecraft.core.world.generate.chunk.ChunkGenerator;
 import net.minecraft.core.world.generate.chunk.perlin.overworld.ChunkGeneratorOverworld;
diff --git a/util/logging/src/main/java/com/mojang/logging/LogUtils.java b/util/logging/src/main/java/com/mojang/logging/LogUtils.java
index 44820a5ec..9e203f004 100644
--- a/util/logging/src/main/java/com/mojang/logging/LogUtils.java
+++ b/util/logging/src/main/java/com/mojang/logging/LogUtils.java
@@ -21,7 +21,7 @@ public class LogUtils
 {
     public static final String FATAL_MARKER_ID = "FATAL";
     public static final Marker FATAL_MARKER = MarkerFactory.getMarker(FATAL_MARKER_ID);
-//    private static final StackWalker STACK_WALKER = StackWalker.getInstance(StackWalker.Option.RETAIN_CLASS_REFERENCE);
+    private static final StackWalker STACK_WALKER = StackWalker.getInstance(StackWalker.Option.RETAIN_CLASS_REFERENCE);
     
     public static boolean isLoggerActive() {
         final LoggerContext loggerContext = LogManager.getContext();
@@ -72,19 +72,8 @@ public class LogUtils
         return new CategorizedLogger(LoggerFactory.getLogger(getCallerClass().getSimpleName()));
     }
 
-    private static Class<?> getCallerClass() { // Hacky way to replace the STACK_WALKER since STACK_WALKER uses java 9 language features
-        try {
-            StackTraceElement[] stElements = Thread.currentThread().getStackTrace();
-            for (int i=1; i<stElements.length; i++) {
-                StackTraceElement ste = stElements[i];
-                if (!ste.getClassName().equals(LogUtils.class.getName()) && ste.getClassName().indexOf("java.lang.Thread")!=0) {
-                    return Class.forName(ste.getClassName());
-                }
-            }
-        } catch (ClassNotFoundException notFoundException) {
-            System.err.print("Could not find calling class!");
-        }
-        return LogUtils.class;
+    private static Class<?> getCallerClass() {
+        return STACK_WALKER.getCallerClass();
     }
 
 }
